<template>
  <FixedFooter @close="onCancel">
    <button type="button" class="btn btn-primary me-2" @click="onClickSelect" :disabled="insertDisabled">
      <i :class="insertIconClass"></i>
      {{ selectedImagesFormatted }}
    </button>
    <button type="button" class="btn btn-primary me-2" @click="onClear">
      <i class="bi bi-square"></i>
      Clear
    </button>
    <button type="button" class="btn btn-danger" @click="onCancel">
      <i class="bi bi-x-lg"></i>
      Cancel
    </button>
  </FixedFooter>
</template>

<script>
import { computed } from 'vue'
import { useRouter } from 'vue-router'
import { useStore } from 'vuex'
import { FixedFooter } from '../../core'

export default {
  name: 'SelectingFixedFooter',
  components: {
    FixedFooter,
  },
  setup() {
    const router = useRouter()
    const store = useStore()

    const imageCount = computed(() => {
      return store.state.gallery.selectedImages.length
    })

    const insertDisabled = computed(() => {
      return imageCount.value === 0
    })

    const imageNoun = computed(() => {
      return imageCount.value === 1 ? 'image' : 'images'
    })

    const insertIconClass = computed(() => {
      return `bi bi-${imageNoun.value}`
    })

    const selectedImagesFormatted = computed(() => {
      return imageCount.value === 0 ? 'Select images' : `Select ${imageCount.value} ${imageNoun.value}`
    })

    const onClickSelect = () => {
      store.dispatch('gallery/setReturnMode', 'select')
      router.push(store.state.gallery.returnRoute)
    }

    const onClear = () => {
      store.dispatch('gallery/setSelectedImages', [])
    }

    const onCancel = () => {
      store.dispatch('gallery/setSelectedImages', [])
      store.dispatch('gallery/setReturnMode', 'cancel')
      router.push(store.state.gallery.returnRoute)
    }

    return {
      imageCount,
      insertDisabled,
      imageNoun,
      insertIconClass,
      selectedImagesFormatted,
      onClickSelect,
      onClear,
      onCancel,
    }
  },
}
</script>
